Attribute VB_Name = "MODULE1"
Sub AdjustForm()
    Dim X&

    If LineCounter& = 0 Or OutputD1.ScaleHeight = 0 Then Exit Sub
    Call LineFeed

    Open DefaultDirectory$ + "\REPORTS\LASTPAGE.TXT" For Output As #9
    For X& = 0 To TextLineCounter&
        Print #9, TextOnForm$(X&)
    Next X&

    Close #9
    OutputD1!RichText1.LoadFile DefaultDirectory$ + "\REPORTS\LASTPAGE.TXT", 1
    OutputD1.Show
    OutputD1.Caption = XCaption$ & "Data"
End Sub

Sub CheckInputErrors()
    If Val(InputD!txtMonth) = 0 Or Val(InputD!txtDay) = 0 Or Val(InputD!txtYear) = 0 Then
       Call SetErrorFlagNatalData
    End If
    If InputD!txtMonth = "" Or InputD!txtDay = "" Or InputD!txtYear = "" Then
       Call SetErrorFlagNatalData
    End If
    If InputD!txtBirthHour = "" Or InputD!txtBirthMinute = "" Or InputD!txtTZ = "" Then
        Call SetErrorFlagNatalData
    End If
    If InputD!txtLongDeg = "" Or InputD!txtLongMin = "" Then
        Call SetErrorFlagNatalData
    End If
    If InputD!txtLatDeg = "" Or InputD!txtLatMin = "" Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtTZ) < -2 And InputD!optWest.Value = True Then
        Call SetErrorFlagNatalData
    End If

    If Val(InputD1!txtDiurnalMonth) = 0 Or Val(InputD1!txtDiurnalDay) = 0 Or Val(InputD1!txtDiurnalYear) = 0 Then
       Call SetErrorFlagDiurnalData
    End If
    If InputD1!txtDiurnalMonth = "" Or InputD1!txtDiurnalDay = "" Or InputD1!txtDiurnalYear = "" Then
       Call SetErrorFlagDiurnalData
    End If
    If InputD1!txtDiurnalHour = "" Or InputD1!txtDiurnalMinute = "" Or InputD1!txtDiurnalTZ = "" Then
        Call SetErrorFlagDiurnalData
    End If
    If InputD1!txtDiurnalLongDeg = "" Or InputD1!txtDiurnalLongMin = "" Then
        Call SetErrorFlagDiurnalData
    End If
    If InputD1!txtDiurnalLatDeg = "" Or InputD1!txtDiurnalLatMin = "" Then
        Call SetErrorFlagDiurnalData
    End If
    If Val(InputD1!txtDiurnalTZ) < -2 And InputD1!optDiurnalWest.Value = True Then
        Call SetErrorFlagDiurnalData
    End If
End Sub

Sub CheckLatitudeErrors()
    If HS$ = "P" Or HS$ = "K" Then
        If (Val(InputD!txtLatDeg) >= 66 And Val(InputD!txtLatMin) > 0) Or (Val(InputD1!txtDiurnalLatDeg) >= 66 And Val(InputD1!txtDiurnalLatMin) > 0) Then
            InputErrorFlag% = 1
            MsgBox "Your latitude is too high. Lower to 66 degrees, 00 minutes or below OR change house systems.", 64, "Warning!"
        End If
    End If
End Sub

Sub CheckOverflowErrorsDiurnal()
    If Val(InputD1!txtDiurnalMonth) > 12 Or Val(InputD1!txtDiurnalDay) > 31 Or Val(InputD1!txtDiurnalYear) > 2099 Then
        Call SetErrorFlagDiurnalData
    End If
    If Val(InputD1!txtDiurnalHour) > 12 Or Val(InputD1!txtDiurnalMinute) > 59 Then
        Call SetErrorFlagDiurnalData
    End If
    If Val(InputD1!txtDiurnalTZ) > 12 Or Val(InputD1!txtDiurnalTZ) < -13 Then
        Call SetErrorFlagDiurnalData
    End If
    If Val(InputD1!txtDiurnalLongDeg) > 180 Or Val(InputD1!txtDiurnalLongMin) > 59 Then
        Call SetErrorFlagDiurnalData
    End If
    If Val(InputD1!txtDiurnalLatMin) > 59 Then
        Call SetErrorFlagDiurnalData
    End If
End Sub

Sub CheckOverflowErrorsNatal()
    If Val(InputD!txtMonth) > 12 Or Val(InputD!txtDay) > 31 Or Val(InputD!txtYear) > 2099 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtBirthHour) > 12 Or Val(InputD!txtBirthMinute) > 59 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtTZ) > 12 Or Val(InputD!txtTZ) < -13 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtLongDeg) > 180 Or Val(InputD!txtLongMin) > 59 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtLatMin) > 59 Then
        Call SetErrorFlagNatalData
    End If
    'If Val(InputD!txtYear) < 100 Then
    '    Call SetErrorFlagNatalData
    'End If
End Sub

Sub ClearOutputForm()
    OutputD1.ScaleMode = 4
    If Interpretations% = 1 Then
        Interpretations% = 0
        OutputD1!mnuMore.Visible = False
    End If
    OutputD1!mnuMoreNewDate.Visible = False
    TextLineCounter& = 0: 'clear buffer for form
    ReDim TextOnForm$(0 To 1)
End Sub

Sub Convert360toDM()
        z3 = Int(z): Q = Int(z3 / 30) + 1
        z1 = Int(RoundTo2Dec((z3 / 30 - Int(z3 / 30)) * 30))
        z2a = (z - z3) * 60
        z2 = Int(z2a + 0.5): If z2 >= 60 Then z2 = 59: 'fixed 4-26-91
End Sub

Sub Convert360toDMS()
        z3 = Int(z): Q = Int(z3 / 30) + 1
        z1 = Int(RoundTo2Dec((z3 / 30 - Int(z3 / 30)) * 30))
        z2a = (z - z3) * 60: z2 = Int(z2a)
        z2a = Int((z2a - Int(z2a)) * 60)
End Sub

Function ConvertDMtoDec(X)
        ConvertDMtoDec = Int(X) + ((X - Int(X)) * 100) / 60
End Function

Function DEGREES(X)
        DEGREES = X * 180 / 3.1415926535
End Function

Sub DiurnalCaptions()
    Wheels2Captions$(2) = Format$(DiurnalDate$, "dd mmm yyyy")
    Wheels2Captions$(3) = Format$(DiurnalTime!, "#0.00") & " " & DiurnalBirthTime$ & " (" & DiurnalTimeZone! & ")"
    Wheels2Captions$(4) = Format$(Abs(DiurnalLong!), "##0.00") & " " & DiurnalD1$
    Wheels2Captions$(5) = Format$(Abs(DiurnalLat!), "#0.00") & " " & DiurnalD2$
    Wheels2Captions$(6) = ""
End Sub

Sub DiurnalDataList()
    Buffer = Space$(2) + Format$(DiurnalDate$, "dd mmm yyyy") + Space$(4) + "TZ = " + Format$(DiurnalTimeZone!, "##0.0")
    Buffer = Buffer + Space$(6) + Format$(DiurnalTime!, "#0.00") + " " + DiurnalBirthTime$
    Buffer = Buffer + Space$(3) + Format$(Abs(DiurnalLat!), "##0.00") + " " + DiurnalD2$ + Space(4) + Format$(Abs(DiurnalLong!), "##0.00") + " " + DiurnalD1$
    Call PrintBuffer
End Sub

Sub DualNatalVSTransit()
    Dim X%

    ReDim Wheels1Captions$(7), Wheels2Captions$(7)

    If InputD1!chk2ndPerson.Value = 0 Then
        Wheels!mnuSwitch.Visible = False
    Else
        Wheels!mnuSwitch.Visible = True
    End If

    Call HouseCaptions
    CurrentOrbsFile$ = DefaultDirectory$ & "\NAT2TRAN.ORB"
    If NatOrTranOuter% = 0 Then
        Wheels1Captions$(1) = ZN$ & " - natal"

        Wheels1Captions$(2) = Format$(NatalDate$, "dd mmm yyyy")
        Wheels1Captions$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
        Wheels1Captions$(4) = Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
        Wheels1Captions$(5) = Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
        Wheels1Captions$(6) = NatalST: Call HouseCaptions: ReDim Wheels2Captions$(7)

        Wheels2Captions$(1) = "Diurnal data"
        Wheels2Captions$(2) = Format$(DiurnalDate$, "dd mmm yyyy")
        Wheels2Captions$(3) = Format$(DiurnalTime!, "#0.00") & " " & DiurnalBirthTime$ & " (" & DiurnalTimeZone! & ")"
        Wheels2Captions$(4) = Format$(Abs(DiurnalLong!), "##0.00") & " " & DiurnalD1$
        Wheels2Captions$(5) = Format$(Abs(DiurnalLat!), "#0.00") & " " & DiurnalD2$
        Wheels2Captions$(6) = "Inner = transits"
        'If InputD1!chk2ndPerson.Value = 1 Then
        '    If XOPTION!(216) <> 0 Then Wheels2Captions$(6) = "Outer = transits"
        'End If

        If InputD1!chk2ndPerson.Value = 1 Then
            Wheels2Captions$(1) = InputD1!chk2ndPerson.Caption
            Wheels2Captions$(6) = TransitST
            Wheels2Captions$(7) = "Inner - natal"
            CurrentOrbsFile$ = DefaultDirectory$ & "\SYNASTRY.ORB"
        End If

        For X% = 1 To 13: HC(X%) = NatalHouse(X%): Next X%

        For X% = 1 To NumberOfPlanets%
            Planets(X%) = Natal(X%)
        Next X%

        Retrograde$ = NatalH$
        ax1$ = NatalDate$: SiderealTime$ = NatalST$

        ph$ = NatalPH$

        OuterPH$ = ph$
        LO = NatalLong!: LA = NatalLat!: d1$ = NatalD1$: d2$ = NatalD2$

        For X% = 1 To NumberOfPlanets%
            p1(X%) = Transit(X%)
        Next X%
        h1$ = TransitH$
    Else
        Wheels1Captions$(1) = InputD1!chk2ndPerson.Caption & " - natal"
        Wheels1Captions$(2) = Format$(DiurnalDate$, "dd mmm yyyy")
        Wheels1Captions$(3) = Format$(DiurnalTime!, "#0.00") & " " & DiurnalBirthTime$ & " (" & DiurnalTimeZone! & ")"
        Wheels1Captions$(4) = Format$(Abs(DiurnalLong!), "##0.00") & " " & DiurnalD1$
        Wheels1Captions$(5) = Format$(Abs(DiurnalLat!), "#0.00") & " " & DiurnalD2$
        Wheels1Captions$(6) = TransitST: Call HouseCaptions: ReDim Wheels2Captions$(7)

        Wheels2Captions$(1) = "Diurnal data"
        Wheels2Captions$(2) = Format$(NatalDate$, "dd mmm yyyy")
        Wheels2Captions$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
        Wheels2Captions$(4) = Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
        Wheels2Captions$(5) = Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
        Wheels2Captions$(6) = "Inner = transits"

        If InputD1!chk2ndPerson.Value = 1 Then
            Wheels2Captions$(1) = ZN$
            Wheels2Captions$(6) = NatalST: Wheels2Captions$(7) = "Inner - natal"
            CurrentOrbsFile$ = DefaultDirectory$ & "\SYNASTRY.ORB"
        End If

        For X% = 1 To 13: HC(X%) = TransitHouse(X%): Next X%

        For X% = 1 To NumberOfPlanets%
            Planets(X%) = Transit(X%)
        Next X%

        Retrograde$ = TransitH$ & NatalH$

        ax1$ = DiurnalDate$: SiderealTime$ = DiurnalST$

        ph$ = TransitPH$
        OuterPH$ = ph$

        LO = DiurnalLong!: LA = DiurnalLat!: d1$ = DiurnalD1$: d2$ = DiurnalD2$

        For X% = 1 To NumberOfPlanets%: p1(X%) = Natal(X%): Next X%: h1$ = NatalH$
    End If

    XSTEP% = 0: InnerOuter% = 1: NatORSyn% = 1: WheelType% = 2

    Unload Wheels: Wheels.Show
End Sub

Sub FetchDiurnalData()
        DiurnalDay% = InputD1!txtDiurnalDay.Text: DiurnalYear% = InputD1!txtDiurnalYear.Text
        DiurnalMonth% = InputD1!txtDiurnalMonth.Text
        If MyiDate% = 2 Then
            Calendar$ = InputD1!txtDiurnalYear.Text + "/" + InputD1!txtDiurnalMonth.Text + "/" + InputD1!txtDiurnalDay.Text
        ElseIf MyiDate% = 1 Then
            Calendar$ = InputD1!txtDiurnalDay.Text + "/" + InputD1!txtDiurnalMonth.Text + "/" + InputD1!txtDiurnalYear.Text
        Else
            Calendar$ = InputD1!txtDiurnalMonth.Text + "/" + InputD1!txtDiurnalDay.Text + "/" + InputD1!txtDiurnalYear.Text
        End If
        DiurnalDate$ = Calendar$
        If DiurnalMonth% < NatalMonth% Then GoTo IGT1
        If DiurnalMonth% > NatalMonth% Then GoTo IGT1
IGT1:
        DiurnalTime! = InputD1!txtDiurnalHour.Text + InputD1!txtDiurnalMinute.Text / 100
        DiurnalTimeZone! = InputD1!txtDiurnalTZ.Text

        If InputD1!optDiurnalAM.Value = -1 Then DiurnalBirthTime$ = "A.M." Else DiurnalBirthTime$ = "P.M."

        DiurnalLong! = InputD1!txtDiurnalLongDeg.Text + InputD1!txtDiurnalLongMin.Text / 100
        If InputD1!optDiurnalEast.Value = -1 Then
            DiurnalLong! = -DiurnalLong!
        End If
        If DiurnalLong! < 0 Then
            DiurnalD1$ = "East"
        Else
            DiurnalD1$ = "West"
        End If

        DiurnalLat! = InputD1!txtDiurnalLatDeg.Text + InputD1!txtDiurnalLatMin.Text / 100
        If InputD1!optDiurnalSouth.Value = -1 Then
            DiurnalLat! = -DiurnalLat!
        End If
        If DiurnalLat! < 0 Then
            DiurnalD2$ = "South"
        Else
            DiurnalD2$ = "North"
        End If
End Sub

Sub FetchNatalData()
        D = InputD!txtDay.Text: Y = InputD!txtYear.Text
        M = InputD!txtMonth.Text: t = InputD!txtTZ.Text
        NatalDay% = D: NatalMonth% = M: NatalYear% = Y
        If MyiDate% = 2 Then
            Calendar$ = InputD!txtYear.Text + "/" + InputD!txtMonth.Text + "/" + InputD!txtDay.Text
        ElseIf MyiDate% = 1 Then
            Calendar$ = InputD!txtDay.Text + "/" + InputD!txtMonth.Text + "/" + InputD!txtYear.Text
        Else
            Calendar$ = InputD!txtMonth.Text + "/" + InputD!txtDay.Text + "/" + InputD!txtYear.Text
        End If
        NatalDate$ = Calendar$
        F = InputD!txtBirthHour.Text + InputD!txtBirthMinute.Text / 100
        NatalTime! = F: NatalTimeZone! = t

        If InputD!optAM.Value = -1 Then NatalBirthTime$ = "A.M." Else NatalBirthTime$ = "P.M."
        AMorPM$ = NatalBirthTime$

        NatalLong! = InputD!txtLongDeg.Text + InputD!txtLongMin.Text / 100
        If InputD!optEast.Value = -1 Then
            NatalLong! = -NatalLong!
        End If
        If NatalLong! < 0 Then
            NatalD1$ = "East"
        Else
            NatalD1$ = "West"
        End If

        NatalLat! = InputD!txtLatDeg.Text + InputD!txtLatMin.Text / 100
        If InputD!optSouth.Value = -1 Then
            NatalLat! = -NatalLat!
        End If
        If NatalLat! < 0 Then
            NatalD2$ = "South"
        Else
            NatalD2$ = "North"
        End If
End Sub

Sub GetAspectOptions()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open CurrentOrbsFile$ For Input As #2
    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: CWAspects!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Sub GetAtlas()
    Dim X%, xx%, t$, t1$, t2$, TITLE_X, Msg, DgDef

ga_top:
    ExecCmd AtlasDirectory$ & "ATLAS.EXE"

    If ShellWorked& = 0 Then
        AtlasDirectory$ = ""
        t$ = "Enter the complete path for where ATLAS.EXE resides: " & crlf & crlf
        t1$ = "(Example: c:\atlas OR c:\charts\atlas OR d:\windows\atlas\)"
        AtlasDirectory$ = InputBox(t$ & t1$, "Where do I find ATLAS.EXE?", "")
        If AtlasDirectory$ = "" Then ErrFlag% = 0: Exit Sub
        If Right$(AtlasDirectory$, 1) <> "\" Then AtlasDirectory$ = AtlasDirectory$ & "\"
        GoTo ga_top
    End If

    On Error GoTo er1b
    Open AtlasDirectory$ & "PCATPATH.TXT" For Input As #1
    Line Input #1, DataPath$
    Close #1

    On Error GoTo er1c
    Open DataPath$ & "TSRTEMP.TXT" For Input As #1
    Line Input #1, t$
    Line Input #1, AtlasLatitude$
    Line Input #1, AtlasLongitude$
    Line Input #1, t$
    Line Input #1, t$
    Close #1: On Error GoTo 0

    AtlasTimeZone! = Val(t$)

    Msg = "Accept following data? " & crlf & crlf
    t$ = "Longitude = " & AtlasLongitude$ & crlf
    t1$ = "Latitude  = " & AtlasLatitude$ & crlf
    t2$ = "Time zone = " & Str$(AtlasTimeZone!)
    DgDef = MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1
    TITLE_X = "Accept or Reject data"

    RSVP% = MsgBox(Msg & t$ & t1$ & t2$, DgDef, TITLE_X)
    Exit Sub

er1a:
    AtlasDirectory$ = ""
    t$ = "Enter the complete path for where ATLAS.EXE resides: " & crlf & crlf
    t1$ = "(Example: c:\atlas OR c:\charts\atlas OR d:\windows\atlas\)"
    AtlasDirectory$ = InputBox(t$ & t1$, "Where do I find ATLAS.EXE?", "")
    If AtlasDirectory$ = "" Then ErrFlag% = 0: Exit Sub
    If Right$(AtlasDirectory$, 1) <> "\" Then AtlasDirectory$ = AtlasDirectory$ & "\"
    Resume

er1b:
    MsgBox "Cannot find the file called PCATPATH in the " & AtlasDirectory$ & " directory.", 16, "Warning!"
    Close: ErrFlag% = 0: Exit Sub

er1c:
    MsgBox "Cannot find the file called TSRTEMP.TXT in the " & DataPath$ & " directory.", 16, "Warning!"
    Close: ErrFlag% = 0: Exit Sub
End Sub

Sub GetOptions()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open DefaultDirectory + "\OPTIONS.OPT" For Input As #2
    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: XOPTION!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Sub HouseCaptions()
    If HS$ = "P" Then Wheels1Captions$(7) = "Placidus"
    If HS$ = "R" Then Wheels1Captions$(7) = "Regiomontanus"
    If HS$ = "K" Then Wheels1Captions$(7) = "Koch"
    If HS$ = "C" Then Wheels1Captions$(7) = "Campanus"
    If HS$ = "O" Then Wheels1Captions$(7) = "Porphyry"
    If HS$ = "B" Then Wheels1Captions$(7) = "Alcabitus"
    If HS$ = "T" Then Wheels1Captions$(7) = "Topocentric"
End Sub

Sub HOUSELIST()
'print out all 12 house cusps
    Call LineFeed: Buffer = Space(2) + "HOUSE CUSPS - "

    If HS$ = "R" Then Buffer = Buffer + "Regiomontanus"
    If HS$ = "P" Then Buffer = Buffer + "Placidus"
    If HS$ = "K" Then Buffer = Buffer + "Koch"
    If HS$ = "C" Then Buffer = Buffer + "Campanus"
    If HS$ = "O" Then Buffer = Buffer + "Porphyry"
    If HS$ = "B" Then Buffer = Buffer + "Alcabitus"
    If HS$ = "T" Then Buffer = Buffer + "Topocentric"

    Call PrintBuffer: Buffer = "": LF1 = 0
    For I = 1 To 12
        z = HC(I)
        If LF1 = 0 Then
            Buffer = Buffer + Space(2)
        Else
            Buffer = Buffer + Space(1)
        End If
        Buffer = Buffer + Mid$(HCX1$, I * 4 - 3, 4) + " house = "
        Call PrintSignData
        LF1 = LF1 + 1: If LF1 = 3 Then Call PrintBuffer: LF1 = 0: Buffer = ""
    Next I
End Sub

Sub LineFeed()
        Buffer = "": Call PrintBuffer
End Sub

Sub LoadNow_Natal()
    InputD1!txtDiurnalHour.Text = InputD!txtBirthHour.Text
    InputD1!txtDiurnalMinute.Text = InputD!txtBirthMinute.Text

    InputD1!txtDiurnalTZ.Text = InputD!txtTZ.Text
    InputD1!txtDiurnalLongDeg.Text = InputD!txtLongDeg.Text
    InputD1!txtDiurnalLongMin.Text = InputD!txtLongMin.Text
    InputD1!txtDiurnalLatDeg.Text = InputD!txtLatDeg.Text
    InputD1!txtDiurnalLatMin.Text = InputD!txtLatMin.Text

    InputD1!optDiurnalAM.Value = InputD!optAM.Value
    InputD1!optDiurnalPM.Value = InputD!optPM.Value

    InputD1!optDiurnalEast.Value = InputD!optEast.Value
    InputD1!optDiurnalWest.Value = InputD!optWest.Value

    InputD1!optDiurnalNorth.Value = InputD!optNorth.Value
    InputD1!optDiurnalSouth.Value = InputD!optSouth.Value
End Sub

Sub LoadNow_Options()
    Dim t$

    t$ = Now
    InputD1!optDiurnalAM = True
    If MyiTime% = 1 Then
        If Val(Format$(t$, "h")) >= 12 Then InputD1!optDiurnalPM = True
    Else
        If UCase$(Right$(t$, 2)) = "PM" Then InputD1!optDiurnalPM = True
    End If

    InputD1!txtDiurnalMonth.Text = Format$(Now, "m")
    InputD1!txtDiurnalDay.Text = Format$(Now, "d")
    InputD1!txtDiurnalYear.Text = Format$(Now, "yyyy")

    InputD1!txtDiurnalHour.Text = Format$(Now, "h")
    InputD1!txtDiurnalMinute.Text = Format$(Now, "n")

    InputD1!txtDiurnalTZ.Text = XOPTION!(18)
    InputD1!txtDiurnalLongDeg.Text = XOPTION!(19)
    InputD1!txtDiurnalLongMin.Text = XOPTION!(20)
    InputD1!txtDiurnalLatDeg.Text = XOPTION!(22)
    InputD1!txtDiurnalLatMin.Text = XOPTION!(23)

    If XOPTION!(21) = 0 Then
        InputD1!optDiurnalWest = True
    Else
        InputD1!optDiurnalEast = True
    End If

    If XOPTION!(24) = 0 Then
        InputD1!optDiurnalNorth = True
    Else
        InputD1!optDiurnalSouth = True
    End If
End Sub

Sub NatalCaptions()
    ReDim Wheels1Captions$(7)
    Wheels1Captions$(1) = ZN$ & " - natal"
    Wheels1Captions$(2) = Format$(NatalDate$, "dd mmm yyyy")
    Wheels1Captions$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
    Wheels1Captions$(4) = Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
    Wheels1Captions$(5) = Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
    Wheels1Captions$(6) = NatalST
    Call HouseCaptions: ReDim Wheels2Captions$(7)
End Sub

Sub NatalDataList()
        Call LineFeed
        Buffer = Space(2) & ZN$: Call PrintBuffer
        Buffer = Space$(2) + Format$(NatalDate$, "dd mmm yyyy") + Space$(4) + "TZ = " + Format$(NatalTimeZone!, "##0.0")
        Buffer = Buffer + Space$(6) + Format$(NatalTime!, "#0.00") + " " + NatalBirthTime$
        Buffer = Buffer + Space$(3) + Format$(Abs(NatalLat!), "##0.00") + " " + NatalD2$ + Space(4) + Format$(Abs(NatalLong!), "##0.00") + " " + NatalD1$
        Call PrintBuffer
End Sub

Sub NatalDiurnalDataList()
        Call LineFeed
        Buffer = Space(2) & ZN$: Call PrintBuffer
        Buffer = Space$(2) + Format$(NatalDate$, "dd mmm yyyy") + Space$(4) + "TZ = " + Format$(NatalTimeZone!, "##0.0")
        Buffer = Buffer + Space$(6) + Format$(NatalTime!, "#0.00") + " " + NatalBirthTime$
        Buffer = Buffer + Space$(3) + Format$(Abs(NatalLat!), "##0.00") + " " + NatalD2$ + Space(4) + Format$(Abs(NatalLong!), "##0.00") + " " + NatalD1$
        Call PrintBuffer
        Buffer = Space(2) + "Diurnal date = " + Format$(DiurnalDate$, "dd mmm yyyy"): Call PrintBuffer
End Sub

Sub NatalList()
        XSTEP% = 0: For XAO% = 1 To NumberOfPlanets%: Planets(XAO%) = Natal(XAO%): DECL(XAO%) = NatalDecl(XAO%)
        Next XAO%: For XAP% = 1 To 13: HC(XAP%) = NatalHouse(XAP%): Next XAP%
        ph$ = NatalPH$: Retrograde$ = NatalH$

        Call HOUSELIST
        Call NatalPlanetList
End Sub

Sub NatalPlanetList()
        Call LineFeed: I = 1: Call PlanetSR1: Call PrintNatalPlanetDecl
        I = 10: Call PlanetSR1: Call PrintNatalPlanetDecl
        For I = 2 To NumberOfPlanets%
        If I <> 10 And I <> 12 Then
            Call PlanetSR1: Call PrintNatalPlanetDecl
        End If
        Next I
End Sub

Sub ParallelList()
        DA = Abs(Abs(z1) - Abs(z2))
        If DA > XOPTION!(6) Then Exit Sub
        Buffer = Space(2) + Mid$(PX1$, Y * 10 - 9, 8) + Space(10)
        If (z1 >= 0 And z2 >= 0) Or (z1 < 0 And z2 < 0) Then Buffer = Buffer + "Parallel  "
        If (z1 >= 0 And z2 < 0) Or (z1 < 0 And z2 >= 0) Then Buffer = Buffer + "C.Parallel"
        Buffer = Buffer + Space(4) + Mid$(PX1$, X * 10 - 9, 8)
        If DA >= 0 Then
            Buffer = Buffer + Space(5)
        Else
            Buffer = Buffer + Space(4)
        End If
        Buffer = Buffer + Format$(DA, "0.0") + " degrees"
        Call PrintBuffer
End Sub

Function PickAFile(Wild As String) As String
    Dim X%

    Load SelectFIle
    SelectFIle.filList.Pattern = Wild
    SelectedFile = CurrentNamesFile$
    SelectFIle!filList.ListIndex = 0
    For X% = 0 To SelectFIle!filList.ListCount - 1
        If UCase$(Right$(CurrentNamesFile$, Len(SelectFIle!filList.List(X%)))) = UCase$(SelectFIle!filList.List(X%)) Then
           SelectFIle!filList.ListIndex = X%: Exit For
        End If
    Next X%

    SelectFIle.Show 1
    PickAFile = SelectedFile
End Function

Function PickAFile2(Wild As String) As String
    Dim X%

    Load SelectFIle
    SelectFIle.filList.Pattern = Wild
    SelectedFile = CurrentGeographyFile$
    SelectFIle!filList.ListIndex = 0
    For X% = 0 To SelectFIle!filList.ListCount - 1
        If UCase$(Right$(CurrentGeographyFile$, Len(SelectFIle!filList.List(X%)))) = UCase$(SelectFIle!filList.List(X%)) Then
           SelectFIle!filList.ListIndex = X%: Exit For
        End If
    Next X%

    SelectFIle.Show 1
    PickAFile2 = SelectedFile
End Function

Sub PlanetList()
        Call LineFeed
        I = 1: Call PlanetSR1: Call PrintPlanetDecl
        I = 10: Call PlanetSR1: Call PrintPlanetDecl
        For I = 2 To NumberOfPlanets%: If I = 10 Or I = 12 Then GoTo PL11
        Call PlanetSR1: Call PrintPlanetDecl
PL11:   Next I
        If XSTEP% = 3 Then
            Buffer = Space(51) + "Decl." & Space(3) & "Solstice Pt": Call PrintBuffer
        End If
End Sub

Sub PlanetSR1()
        z = Planets(I): Buffer = Space(2): Call PrintSignDataSeconds
        Buffer = Buffer + Space(3) + Mid$(PX1$, I * 10 - 9, 10) + Mid$(Retrograde$, I, 1) + Space(4)
        If XSTEP% = 0 Or (XSTEP% = 3 And InputD1!chk2ndPerson.Value = 1) Then
            Buffer = Buffer + "(" + Mid$(ph$, I * 10 - 9, 10) + ")" + Space(4)
        Else
            Buffer = Buffer + Space$(16)
        End If
End Sub

Sub PrintBuffer()
    On Error GoTo PBErr1
    ReDim Preserve OutputLines$(0 To LineCounter& + 1)
    OutputLines$(LineCounter&) = Buffer
    LineCounter& = LineCounter& + 1

    TextOnForm$(TextLineCounter&) = Buffer
    TextLineCounter& = TextLineCounter& + 1
    ReDim Preserve TextOnForm$(0 To TextLineCounter&)
PBErr2: Exit Sub

PBErr1: MsgBox "Buffer cannot hold any more data. Please print and/or clear data buffer before displaying any more data. This message may appear up to 35 times depending on how full the buffer is and how much the program wants to write to it.", 16, "Warning!"
    Resume PBErr2
End Sub

Sub PrintNatalPlanetDecl()
        z = Abs(NatalDecl(I)): Call Convert360toDM
        Buffer = Buffer + Format$(z1, "00") + " "
        If NatalDecl(I) >= 0 Then
            Buffer = Buffer + "N"
        Else
            Buffer = Buffer + "S"
        End If
        Buffer = Buffer + " " + Format$(z2, "00")
        z = Natal(I): Call CalcSPoint: z = SPoint
        Buffer = Buffer & Space(3): Call PrintSignData
        Call PrintBuffer
        If I = NumberOfPlanets% Then
            Buffer = Space(51) + "Decl." & Space(3) & "Solstice Pt"
            Call PrintBuffer
        End If
End Sub

Sub PrintPlanetDecl()
        z = Abs(DECL(I)): Call Convert360toDM
        Buffer = Buffer + Format$(z1, "00") + " "
        If DECL(I) >= 0 Then
            Buffer = Buffer + "N"
        Else
            Buffer = Buffer + "S"
        End If
        Buffer = Buffer + " " + Format$(z2, "00")
        z = Planets(I): Call CalcSPoint: z = SPoint
        Buffer = Buffer & Space(3): Call PrintSignData
        Call PrintBuffer
End Sub

Sub PrintSignData()
    Call Convert360toDM

    Buffer = Buffer & Format$(z1, "00") & " " & Mid$(SX1$, Q * 3 - 2, 3) & " "
    Buffer = Buffer & Format$(z2, "00")
End Sub

Sub PrintSignDataSeconds()
        Call Convert360toDMS
        Buffer = Buffer + Format$(z1, "00") + " " + Mid$(SX1$, Q * 3 - 2, 3) + " "
        Buffer = Buffer + Format$(z2, "00") + "m " + Format$(z2a, "00") + "s"
End Sub

Function Radians(X)
        Radians = X * 3.1415926535 / 180
End Function

Sub RectToPolar()
'BK = radians along the X-axis, Y = radians along the Y-axis
        If Y = 0 Then Y = 0.00000000174533
        R = (BK * BK + Y * Y) ^ 0.5: A = Atn(Y / BK): If A < 0 Then A = A + PI
        If Y < 0 Then A = A + PI
End Sub

Function RoundTo2Dec(X)
        RoundTo2Dec = Int(X * 100 + 0.5) / 100
End Function

Sub SetErrorFlagDiurnalData()
       InputErrorFlag% = 1
       MsgBox "Error in diurnal input data section. Please correct.", 64, "Warning!"
End Sub

Sub SetErrorFlagNatalData()
       InputErrorFlag% = 1
       MsgBox "Error in natal input data section. Please correct.", 64, "Warning!"
End Sub

Sub SetUpDualChartWheel()
        Dim X%
        For X% = 1 To 13: HC(X%) = NatalHouse(X%): Next X%: WheelType% = 2
        For X% = 1 To NumberOfPlanets%: Planets(X%) = Natal(X%): Next X%: Retrograde$ = NatalH$
        ax1$ = NatalDate$: SiderealTime$ = NatalST$: ph$ = NatalPH$: OuterPH$ = ph$
        LO = NatalLong!: LA = NatalLat!: d1$ = NatalD1$: d2$ = NatalD2$
        XSTEP% = 0
End Sub

Function Sine(X)
        Sine = Sin(X * 3.1415926535 / 180)
End Function

Sub TheAspects()
        Dim tx$, DA1, k1(), k2()

        Call GetNatalOrbs

        ReDim NAsp%(NumberOfPlanets%, NumberOfPlanets%, 17), k1(NumberOfPlanets%), k2(NumberOfPlanets%)

're-order the planets - Moon goes after the Sun
        For X = 1 To NumberOfPlanets%
            k1(X) = Planets(X): k2(X) = DECL(X)
        Next X

        DA1 = k1(10)
        For X = 9 To 2 Step -1
            k1(X + 1) = k1(X)
        Next X
        k1(2) = DA1

        DA1 = k2(10)
        For X = 9 To 2 Step -1
            k2(X + 1) = k2(X)
        Next X
        k2(2) = DA1

'print out planet's aspects in graph-type form
        tx$ = "  Planet     Planet    Separation   Degrees from exact" & crlf
        Call LineFeed
        Buffer = Space(22) + "NATAL PLANET ASPECTS TO NATAL PLANETS": Call PrintBuffer
        Call LineFeed
        If XOPTION!(15) = 0 Then
            Buffer = Space(8) + "Chi  MC  Asc  P.F  S.N  N.N  Plu  Nep  Ura  Sat  Jup  Mar  Ven  Mer  Moo  Sun"
        ElseIf XOPTION!(15) = 1 Then
            Buffer = Space(8) + "Chi  MC  Asc  BML  S.N  N.N  Plu  Nep  Ura  Sat  Jup  Mar  Ven  Mer  Moo  Sun"
        End If
        Call PrintBuffer
        For Y = 1 To NumberOfPlanets%: If Y < 11 Or Y > 13 Then Buffer = Space(2) + Left$(MPNames$(Y), 3) + "  "
            If Y = 11 Then Buffer = Space(2) + "N.N  "
            If Y = 12 Then Buffer = Space(2) + "S.N  "
            If XOPTION!(15) = 0 Then
                If Y = 13 Then Buffer = Space(2) + "P.F  "
            ElseIf XOPTION!(15) = 1 Then
                If Y = 13 Then Buffer = Space(2) + "BML  "
            End If
            If Y = 15 Then Buffer = Space(2) + "MC   "
            For X = NumberOfPlanets% To 1 Step -1
                If Y = X Then Buffer = Buffer + "***  ": GoTo PT2G
                If Y < X Then GoTo PT1G
'parallels of declination
                DA = Abs(Abs(k2(Y)) - Abs(k2(X)))
                If DA > Natal_Orbs!(6) Then Buffer = Buffer + "---  ": GoTo PT2G
                If (k2(Y) >= 0 And k2(X) >= 0) Or (k2(Y) < 0 And k2(X) < 0) Then Buffer = Buffer + " P   "
                If (k2(Y) >= 0 And k2(X) < 0) Or (k2(Y) < 0 And k2(X) >= 0) Then Buffer = Buffer + " CP  "
                GoTo PT2G

'longitude aspects
PT1G:           Q = 1: DA = Abs(k1(Y) - k1(X)): If DA > 180 Then DA = 360 - DA
                If DA <= (60 + Natal_Orbs!(2)) And DA >= (60 - Natal_Orbs!(2)) Then Q = 3: DA1 = DA - 60
                If DA <= (90 + Natal_Orbs!(3)) And DA >= (90 - Natal_Orbs!(3)) Then Q = 4: DA1 = DA - 90
                If DA <= (120 + Natal_Orbs!(4)) And DA >= (120 - Natal_Orbs!(4)) Then Q = 5: DA1 = DA - 120
                If DA >= (180 - Natal_Orbs!(5)) Then Q = 6: DA1 = DA - 180
                If DA <= (30 + Natal_Orbs!(7)) And DA >= (30 - Natal_Orbs!(7)) Then Q = 8: DA1 = DA - 30
                If DA <= (45 + Natal_Orbs!(8)) And DA >= (45 - Natal_Orbs!(8)) Then Q = 9: DA1 = DA - 45
                If DA <= (135 + Natal_Orbs!(9)) And DA >= (135 - Natal_Orbs!(9)) Then Q = 10: DA1 = DA - 135
                If DA <= (150 + Natal_Orbs!(10)) And DA >= (150 - Natal_Orbs!(10)) Then Q = 11: DA1 = DA - 150
                If DA <= (36 + Natal_Orbs!(11)) And DA >= (36 - Natal_Orbs!(11)) Then Q = 12: DA1 = DA - 36
                If DA <= (40 + Natal_Orbs!(12)) And DA >= (40 - Natal_Orbs!(12)) Then Q = 13: DA1 = DA - 40
                If DA <= (72 + Natal_Orbs!(13)) And DA >= (72 - Natal_Orbs!(13)) Then Q = 14: DA1 = DA - 72
                If DA <= (108 + Natal_Orbs!(14)) And DA >= (108 - Natal_Orbs!(14)) Then Q = 15: DA1 = DA - 108
                If DA <= (144 + Natal_Orbs!(15)) And DA >= (144 - Natal_Orbs!(15)) Then Q = 16: DA1 = DA - 144
                If DA <= (51.42857143 + Natal_Orbs!(16)) And DA >= (51.42857143 - Natal_Orbs!(16)) Then Q = 17: DA1 = DA - 51.42857143
                If DA <= Natal_Orbs!(1) Then Q = 2: DA1 = DA
                If Q = 1 Or Q > 17 Then Buffer = Buffer + "---  ": GoTo PT2G
                NAsp%(Y, X, Q) = 1
                If ASPECTS%(Q) < 10 Then
                    Buffer = Buffer + "  " + Format$(ASPECTS%(Q), "0") + "  "
                ElseIf ASPECTS%(Q) < 100 Then
                    Buffer = Buffer + " " + Format$(ASPECTS%(Q), "00") + "  "
                Else
                    Buffer = Buffer + Format$(ASPECTS%(Q), "000") + "  "
                End If
                If Y <> 12 Then
                    tx$ = tx$ & Space(2) & MPNames$(Y) & Space(10 - Len(MPNames$(Y)) + 1) & MPNames(X) & Space(10 - Len(MPNames$(X)) + 1)
                    tx$ = tx$ & Align3(Format$(Fix(DA), "##0")) & "d" & Space(1) & Format$((Abs(DA) - Int(Abs(DA))) * 60, "00") & "m" & Space(7)
                    tx$ = tx$ & Align4(Format$(Fix(Abs(DA1)), "#0")) & "d" & Space(1) & Format$((Abs(DA1) - Int(Abs(DA1))) * 60, "00") & "m" & crlf
                End If
PT2G:       Next X
            Call PrintBuffer
        Next Y

        Call LineFeed
        Buffer = Space(4) & "0  = conjunction    60 = sextile          90 = square         120 = trine"
        Call PrintBuffer
        Buffer = Space(2) & "180  = opposition      P = parallel         CP = contra-parallel"
        Call PrintBuffer: Call LineFeed
        Buffer = Space(3) & "30  = semi-sextile   45 = semi-square     135 = sesquisquare   150 = quincunx"
        Call PrintBuffer
        Buffer = Space(3) & "36  = semi-quintile  40 = nonagen          72 = quintile       108 = trecile"
        Call PrintBuffer
        Buffer = Space(2) & "144  = bi-quintile    51 = septile"
        Call PrintBuffer

        Call LineFeed: Call LineFeed: Buffer = tx$: Call PrintBuffer
End Sub

Sub TransitAspectsNatal()
'list transiting planet's aspects to natal planets
    Call GetTransitOrbs

    Call LineFeed
    Buffer = Space(6) + "TRANSITING PLANET ASPECTS TO NATAL PLANETS"
    Call PrintBuffer: Call LineFeed
    For Y = 1 To NumberOfPlanets%
        If Y <> 12 Then
            For X = 1 To NumberOfPlanets%
                If X <> 12 Then
                    DAYY = Transit(Y) - Natal(X)
                    DA = Abs(Transit(Y) - Natal(X))
                    Call Aspects_for_Transits1
                End If
            Next X
        End If
    Next Y
End Sub

Sub TransitAspectsTransits()
'list transiting planet's aspects to transiting planets
    Call GetTransitOrbs

    Call LineFeed
    If InputD1!chk2ndPerson.Value = 0 Then
        Buffer = Space(3) + "TRANSITING PLANET ASPECTS TO TRANSITING PLANETS"
    Else
        Buffer = Space(2) & InputD1!chk2ndPerson.Caption & "'s " & "NATAL PLANETARY ASPECTS"
    End If
    Call PrintBuffer: Call LineFeed

    For Y = 1 To NumberOfPlanets% - 1
        If Y <> 12 Then
            For X = Y + 1 To NumberOfPlanets%
                If X <> 12 Then
                    DAYY = Transit(Y) - Transit(X)
                    DA = Abs(Transit(Y) - Transit(X))
                    Call Aspects_for_Transits1
                End If
            Next X
        End If
    Next Y
End Sub

Sub TransitList()
        XSTEP% = 3: Call LineFeed
        If InputD1!chk2ndPerson.Value = 0 Then
            Buffer = Space(2) + "TRANSIT POSITIONS"
        Else
            Buffer = Space(2) & InputD1!chk2ndPerson.Caption & "'s " & "NATAL POSITIONS"
        End If
        Call PrintBuffer

        Call DiurnalDataList

        For XAW% = 1 To NumberOfPlanets%: Planets(XAW%) = Transit(XAW%): DECL(XAW%) = TransitDecl(XAW%): Next XAW%
        For XAW% = 1 To 13: HC(XAW%) = TransitHouse(XAW%): Next XAW%
        ph$ = TransitPH$: Retrograde$ = TransitH$: Call HOUSELIST
        Call PlanetList
End Sub

Function Align3(A4 As String)
    If Val(A4) >= 100 Then
        Align3 = A4: Exit Function
    ElseIf Val(A4) >= 10 Then
        Align3 = Space(1) & A4: Exit Function
    Else
        Align3 = Space(2) & A4
    End If
End Function

Function Align4(A4 As String)
    If Left$(A4, 3) = "-0," Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) >= 100 Then
        Align4 = Space(1) & A4: Exit Function
    ElseIf Val(A4) >= 10 Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) >= 0 Then
        Align4 = Space(3) & A4: Exit Function
    ElseIf Val(A4) > -10 Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) > -100 Then
        Align4 = Space(1) & A4: Exit Function
    Else
        Align4 = A4
    End If
End Function

Sub AngleDeclinations()
        X = Cosine(Planets(13))
        Y = Cosine(OB) * Sine(Planets(13))
        z = Sine(OB) * Sine(Planets(13))
        Call Cart2Sph: DECL(13) = BETA

        X = Cosine(Planets(14))
        Y = Cosine(OB) * Sine(Planets(14))
        z = Sine(OB) * Sine(Planets(14))
        Call Cart2Sph: DECL(14) = BETA

        X = Cosine(Planets(15))
        Y = Cosine(OB) * Sine(Planets(15))
        z = Sine(OB) * Sine(Planets(15))
        Call Cart2Sph: DECL(15) = BETA
End Sub

Sub Aspects_for_Transits1()
    If DA > 180 Then DA = 360 - DA

    t = 0: Q = 1: K = DA
    If K <= (60 + Transit_Orbs!(2)) And K >= (60 - Transit_Orbs!(2)) Then Q = 3: DA = DA - 60
    If K <= (90 + Transit_Orbs!(3)) And K >= (90 - Transit_Orbs!(3)) Then Q = 4: DA = DA - 90
    If K <= (120 + Transit_Orbs!(4)) And K >= (120 - Transit_Orbs!(4)) Then Q = 5: DA = DA - 120
    If K >= (180 - Transit_Orbs!(5)) Then Q = 6: DA = DA - 180

    If K <= (30 + Transit_Orbs!(7)) And K >= (30 - Transit_Orbs!(7)) Then Q = 8: DA = DA - 30
    If K <= (45 + Transit_Orbs!(8)) And K >= (45 - Transit_Orbs!(8)) Then Q = 9: DA = DA - 45
    If K <= (135 + Transit_Orbs!(9)) And K >= (135 - Transit_Orbs!(9)) Then Q = 10: DA = DA - 135
    If K <= (150 + Transit_Orbs!(10)) And K >= (150 - Transit_Orbs!(10)) Then Q = 11: DA = DA - 150

    If K <= Transit_Orbs!(1) Then Q = 2

    If K <= (36 + Transit_Orbs!(11)) And K >= (36 - Transit_Orbs!(11)) Then Q = 12: DA = DA - 36
    If K <= (40 + Transit_Orbs!(12)) And K >= (40 - Transit_Orbs!(12)) Then Q = 13: DA = DA - 40
    If K <= (72 + Transit_Orbs!(13)) And K >= (72 - Transit_Orbs!(13)) Then Q = 14: DA = DA - 72
    If K <= (108 + Transit_Orbs!(14)) And K >= (108 - Transit_Orbs!(14)) Then Q = 15: DA = DA - 108
    If K <= (144 + Transit_Orbs!(15)) And K >= (144 - Transit_Orbs!(15)) Then Q = 16: DA = DA - 144
    If K <= (51.42857143 + Transit_Orbs!(16)) And K >= (51.42857143 - Transit_Orbs!(16)) Then Q = 17: DA = DA - 51.42857143

    If Q > 1 And Q < 18 Then
        Buffer = Space(2) & Mid$(PX1$, Y * 10 - 9, 8) + Space$(4) + Mid$(AAX1$, Q * 12 - 11, 10) + Space$(4)
        If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then DA = -DA
        Buffer = Buffer + Mid$(PX1$, X * 10 - 9, 8)
        If DA >= 0 Then
            Buffer = Buffer + Space(5)
        Else
            Buffer = Buffer + Space(4)
        End If
        Buffer = Buffer + Format$(DA, "0.00") + " degrees"
        Call PrintBuffer
    End If
End Sub

Sub XHeader1()
    Call ClearOutputForm: Call NatalDataList
End Sub

Sub XHeader2()
    Call ClearOutputForm: Call NatalDiurnalDataList
End Sub

Sub XHeader3()
    Call ClearOutputForm: Call NatalDataList
    Call LineFeed
    Buffer = Space(2) & InputD1!chk2ndPerson.Caption
    Call PrintBuffer
    Call DiurnalDataList: 'Call LineFeed
End Sub

Public Sub Aspects_for_Transits2()
    If DA > 180 Then DA = 360 - DA

    t = 0: Q = 1: K = DA
    If K <= (60 + Transit_Orbs!(2)) And K >= (60 - Transit_Orbs!(2)) Then Q = 3: DA = DA - 60
    If K <= (90 + Transit_Orbs!(3)) And K >= (90 - Transit_Orbs!(3)) Then Q = 4: DA = DA - 90
    If K <= (120 + Transit_Orbs!(4)) And K >= (120 - Transit_Orbs!(4)) Then Q = 5: DA = DA - 120
    If K >= (180 - Transit_Orbs!(5)) Then Q = 6: DA = DA - 180

    If K <= (30 + Transit_Orbs!(7)) And K >= (30 - Transit_Orbs!(7)) Then Q = 8: DA = DA - 30
    If K <= (45 + Transit_Orbs!(8)) And K >= (45 - Transit_Orbs!(8)) Then Q = 9: DA = DA - 45
    If K <= (135 + Transit_Orbs!(9)) And K >= (135 - Transit_Orbs!(9)) Then Q = 10: DA = DA - 135
    If K <= (150 + Transit_Orbs!(10)) And K >= (150 - Transit_Orbs!(10)) Then Q = 11: DA = DA - 150

    If K <= Transit_Orbs!(1) Then Q = 2
End Sub

Public Sub GetNatalOrbs()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open DefaultDirectory + "\NATAL.ORB" For Input As #2

    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: Natal_Orbs!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Public Sub GetTransitOrbs()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open DefaultDirectory + "\NAT2TRAN.ORB" For Input As #2

    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: Transit_Orbs!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Public Sub NatalAspects2ndPersonNatalAspects()
    Dim c As Integer, I As String

'list natal planet aspects to 2nd person's natal planets
    Call LineFeed: Buffer = ""

    Close #2: c = 0
    Open DefaultDirectory + "\SYNASTRY.ORB" For Input As #2

    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: Transit_Orbs!(c) = Val(Left$(I, 7))
    Loop
    Close #2

    For Y = 1 To NumberOfPlanets%
        If Y = 11 Or Y = 12 Or Y = 13 Then GoTo nasp4
        For X = 1 To NumberOfPlanets%
            If X = 11 Or X = 12 Or X = 13 Then GoTo nasp3
            DAYY = Natal(Y) - Transit(X)
            DA = Abs(Natal(Y) - Transit(X))
            If DA > 180 Then DA = 360 - DA

            t = 0: Q = 1: K = DA
            If K <= (60 + Transit_Orbs!(2)) And K >= (60 - Transit_Orbs!(2)) Then Q = 3: DA = DA - 60
            If K <= (90 + Transit_Orbs!(3)) And K >= (90 - Transit_Orbs!(3)) Then Q = 4: DA = DA - 90
            If K <= (120 + Transit_Orbs!(4)) And K >= (120 - Transit_Orbs!(4)) Then Q = 5: DA = DA - 120
            If K >= (180 - Transit_Orbs!(5)) Then Q = 6: DA = DA - 180

            If K <= (30 + Transit_Orbs!(7)) And K >= (30 - Transit_Orbs!(7)) Then Q = 8: DA = DA - 30
            If K <= (45 + Transit_Orbs!(8)) And K >= (45 - Transit_Orbs!(8)) Then Q = 9: DA = DA - 45
            If K <= (135 + Transit_Orbs!(9)) And K >= (135 - Transit_Orbs!(9)) Then Q = 10: DA = DA - 135
            If K <= (150 + Transit_Orbs!(10)) And K >= (150 - Transit_Orbs!(10)) Then Q = 11: DA = DA - 150

            If K <= Transit_Orbs!(1) Then Q = 2
            If Q > 1 And Q < 17 Then
                Buffer = Space(2) & Mid$(PX1$, Y * 10 - 9, 8) + Space$(4) + Mid$(AAX1$, Q * 12 - 11, 10) + Space$(4)
                If DAYY <= -180 Or (DAYY >= 0 And DAYY < 180) Then DA = -DA
                Buffer = Buffer + Mid$(PX1$, X * 10 - 9, 8)
                If DA >= 0 Then
                    Buffer = Buffer + Space(5)
                Else
                    Buffer = Buffer + Space(4)
                End If
                Buffer = Buffer + Format$(DA, "0.0") + " degrees"
                Call PrintBuffer
            End If
nasp3:
        Next X
nasp4:
    Next Y
End Sub

Sub SynastryAspects()
        Dim t

        Call LineFeed
        Buffer = Space(2) & InputD!txtName.Text & "'s " & "NATAL PLANET ASPECTS TO " & InputD1!chk2ndPerson.Caption & "'s " & "NATAL PLANETS"
        Call PrintBuffer
        Buffer = Space(2) & "(Dn = " & ZN$ & ", Across = " & InputD1!chk2ndPerson.Caption & ")"
        Call PrintBuffer: Call LineFeed
        Buffer = Space(7) + "SUN  MER  VEN  MAR  JUP  SAT  URA  NEP  PLU  MOO  N.N  S.N  PoF  ASC   MC  CHI"
        Call PrintBuffer
        For Y = 1 To NumberOfPlanets%: If Y < 11 Or Y > 13 Then Buffer = Space(2) & Left$(PN$(Y), 3) & "  "
        If Y = 11 Then Buffer = Space(2) + "N.N  "
        If Y = 12 Then Buffer = Space(2) + "S.N  "
        If Y = 13 Then Buffer = Space(2) + "PoF  "
        For X = 1 To NumberOfPlanets%

        DA = Abs(Natal(Y) - Transit(X)): If DA > 180 Then DA = 360 - DA
        Q = 1: t = XOPTION!(55): K = DA
        If Y = 11 Or Y = 12 Or X = 11 Or X = 12 Then t = XOPTION!(56)
        If Y = 1 Or Y = 10 Or X = 1 Or X = 10 Then t = XOPTION!(57)

        If K <= (60 + t) And K >= (60 - t) Then Q = 3
        If K <= (90 + t) And K >= (90 - t) Then Q = 4
        If K <= (120 + t) And K >= (120 - t) Then Q = 5
        If K <= (150 + XOPTION!(58)) And K >= (150 - XOPTION!(58)) Then Q = 11
        If K <= (135 + XOPTION!(58)) And K >= (135 - XOPTION!(58)) Then Q = 10
        If K <= (45 + XOPTION!(58)) And K >= (45 - XOPTION!(58)) Then Q = 9
        If K <= (30 + XOPTION!(58)) And K >= (30 - XOPTION!(58)) Then Q = 8
        If K >= (180 - t) Then Q = 6
        If K <= t Then Q = 2

        If Q = 1 Then Buffer = Buffer & "---  ": GoTo PT4GX
        If ASPECTS%(Q) < 10 Then
            Buffer = Buffer + "  " + Format$(ASPECTS%(Q), "0") + "  "
        ElseIf ASPECTS%(Q) < 100 Then
            Buffer = Buffer + " " + Format$(ASPECTS%(Q), "00") + "  "
        Else
            Buffer = Buffer + Format$(ASPECTS%(Q), "000") + "  "
        End If
PT4GX:  Next X: Call PrintBuffer: Next Y
        Call LineFeed
        Buffer = Space(4) & "0  = conjunction       60 = sextile          90 = square         120 = trine"
        Call PrintBuffer
        Buffer = Space(2) & "180  = opposition        30 = semi-sextile    150 = quincunx"
        Call PrintBuffer
        Buffer = Space(3) & "45  = semi-square      135 = sesquisquare"
        Call PrintBuffer
End Sub

Sub SynastryParallels()
        Dim t

        Call LineFeed
        Buffer = Space(7) + "SUN  MER  VEN  MAR  JUP  SAT  URA  NEP  PLU  MOO  N.N  S.N  PoF  ASC   MC  CHI"
        Call PrintBuffer
        For Y = 1 To NumberOfPlanets%: If Y < 11 Or Y > 13 Then Buffer = Space(2) & Left$(PN$(Y), 3) & "  "
        If Y = 11 Then Buffer = Space(2) + "N.N  "
        If Y = 12 Then Buffer = Space(2) + "S.N  "
        If Y = 13 Then Buffer = Space(2) + "PoF  "
        For X = 1 To NumberOfPlanets%: DA = Abs(Abs(NatalDecl(Y)) - Abs(TransitDecl(X)))
        Q = 1: K = DA: If K > 1# Then Buffer = Buffer & "---  ": GoTo PT8GX
        If (NatalDecl(Y) >= 0 And TransitDecl(X) >= 0) Or (NatalDecl(Y) < 0 And TransitDecl(X) < 0) Then Buffer = Buffer + " P   "
        If (NatalDecl(Y) >= 0 And TransitDecl(X) < 0) Or (NatalDecl(Y) < 0 And TransitDecl(X) >= 0) Then Buffer = Buffer + " CP  "
PT8GX:  Next X: Call PrintBuffer: Next Y
End Sub

Sub GetCalendarDay()
    Dim A$, X$, LW, ITW, KW, IKW, NW, JTW

'convert Julian Day (JD#) to day, month, year format
    LW = Int(jd# + 0.5) + 68569: NW = Int(4 * LW / 146097)
    LW = LW - Int((146097 * NW + 3) / 4)
    ITW = Int(4000 * (LW + 1) / 1461001)
    LW = LW - Int(1461 * ITW / 4) + 31: JTW = Int(80 * LW / 2447)
    KW = LW - Int(2447 * JTW / 80)
    LW = Int(JTW / 11): JTW = JTW + 2 - 12 * LW
    IKW = 100 * (NW - 49) + ITW + LW
'JTW = month, KW = day, IKW = year
    X$ = Str$(JTW): If JTW < 10 Then X$ = "0" + LTrim$(X$)
    A$ = Str$(KW): If KW < 10 Then A$ = "0" + LTrim$(A$)
    X$ = LTrim$(X$): A$ = LTrim$(A$)
    If MyiDate% = 2 Then
        Calendar$ = LTrim$(Right$(Str$(IKW), 4) + "/" + X$ + "/" + A$)
    ElseIf MyiDate% = 1 Then
        Calendar$ = LTrim$(A$ + "/" + X$ + "/" + Right$(Str$(IKW), 4))
    Else
        Calendar$ = LTrim$(X$ + "/" + A$ + "/" + Right$(Str$(IKW), 4))
    End If
End Sub

Sub GetJulianDay()
'Find Julian Day for noon of day in question
        XIM = 12 * (XYear + 4800) + XMonth - 3
        XJD = (2 * (XIM - Int(XIM / 12) * 12) + 7 + 365 * XIM) / 12
        XJD = Int(XJD) + XDAY + Int(XIM / 48) - 32083
        If XJD <= 2299171 Then Exit Sub
        XJD = (XJD + Int(XIM / 4800) - Int(XIM / 1200) + 38)
End Sub

Sub GetXCaption()
    XCaption$ = "AstroSrc " & "(Tropical zodiac) - "
End Sub

Function Cosine(X)
        Cosine = Cos(X * PI / 180)
End Function

Function CRUNCH(X)
        If X >= 0 Then
            CRUNCH = X - Int(X / 360) * 360
            Exit Function
        End If
        If X < 0 Then CRUNCH = 360 + (X - ((1 + Int(X / 360)) * 360))
End Function


Public Sub GetOptions_90()
    Dim t$

    num_pl_bodies_90% = 1
    ReDim pl_body_name_90$(1)

    Close #2
    Open DefaultDirectory & "\OPTIONS_90.OPT" For Input As #2

    Do While Not EOF(2)
        Line Input #2, t$

        If t$ <> "" Then
            pl_body_name_90$(num_pl_bodies_90%) = t$
            num_pl_bodies_90% = num_pl_bodies_90% + 1
            ReDim Preserve pl_body_name_90$(num_pl_bodies_90%)
        End If
    Loop

    Close #2

    num_pl_bodies_90% = num_pl_bodies_90% - 1
End Sub
